﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
#ExcludeFromLibrary: True
#IgnoreWarnings: 9

Sub Class_Globals
	Private fx As JFX
	Private TheURL As String
	Private Ser As B4XSerializator
	Private SQL1 As SQL
	#If B4i
	Private C As Cipher
	#Else
	Private C As B4XCipher
	#End If
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	SQL1.Initialize2("com.mysql.jdbc.Driver", "jdbc:mysql://45.55.239.204/RemoteUniverseTest?characterEncoding=utf8", "RUT", "RUT12345")
	LogDebug (SQL1.IsInitialized)
End Sub

#Region "Table Actions"
Public Sub CreateTable (Table As String)
	Table = CorrectTable(Table)
	SQL1.ExecNonQuery($"CREATE TABLE IF NOT EXISTS `${Table}`( `Key` VARCHAR(255) PRIMARY KEY, `Value` BLOB )"$)	
End Sub

Public Sub ListTables
'	Dim RS As ResultSet = SQL1.ExecQuery("SHOW TABLES")
'	Dim Count As Int = 0
'	Do While RS.NextRow
'		Count = Count + 1
'		Log (RS.GetBlob2(Count))
'	Loop
End Sub
#End Region

#Region "Main-Actions"
Public Sub Put (Table As String, Key As String, Value As Object)
	Table = CorrectTable(Table)
	SQL1.ExecNonQuery($"REPLACE INTO `${Table}`(`Key`,`Value`) VALUES("${Key}","${Ser.ConvertObjectToBytes(Value)}")"$)
End Sub

Public Sub Get (Table As String, Key As String) As Object
	Table = CorrectTable(Table)
	Dim RS As ResultSet = SQL1.ExecQuery($"SELECT `Value` FROM `${Table}` WHERE `Key` = "${Key}""$)
	Dim Result As Object = Null
	If RS.NextRow Then
		Result = Ser.ConvertBytesToObject(RS.GetBlob2(0))
	End If
	Return Result
End Sub
#End Region

#Region "Sub-Actions"
Public Sub PutEncrypted(Table As String, Key As String, Value As Object, Password As String)
	Table = CorrectTable(Table)
	Put(Table, Key, C.Encrypt(Ser.ConvertObjectToBytes(Value), Password))
End Sub

#If Not (B4A)
Public Sub PutImage(Table As String, Key As String, Value As Image)
	Table = CorrectTable(Table)
	Put(Table, Key, Ser.ConvertObjectToBytes(Value))
End Sub
#Else

#End If
Public Sub GetEncrypted(Table As String, Key As String, Password As String)
	
End Sub
#End Region

#Region "Other Actions"
Public Sub Close
	SQL1.Close
End Sub
#End Region

#Region "Private Code"
Private Sub CorrectTable (Table As String) As String
	Table = Table.Replace(" ", "_")
	Return Table
End Sub
#End Region